#include <Rcpp.h>
using namespace Rcpp;
using std::abs;
// [[Rcpp::export]]
NumericVector mean_CV_faster(NumericMatrix rrij, IntegerMatrix ttij, IntegerVector hh_vec, int ntimepoints){
  int nind=rrij.nrow();
  int nobs=rrij.ncol();
  int nhh=hh_vec.size();
  NumericVector U(3);
  NumericVector V(2);
  NumericVector mu(ntimepoints),mu_leave(nobs);
  NumericVector CV(nhh,0.0);
  double diff=0;
  double k=0;
  double hh;
  int tt,ii,jj,iileave,jjleave,hh_int,hh_index;
  for(hh_index=0;hh_index<nhh;hh_index++){
    hh_int=hh_vec(hh_index);
    hh=hh_int;
    for(iileave=0;iileave<nind;iileave++){
      for(jjleave=0;jjleave<nobs;jjleave++){
        U(0)=0;U(1)=0;U(2)=0;
        V(0)=0;V(1)=0;
        tt=ttij(iileave,jjleave);
        for(ii=0;ii<nind;ii++){
          if(ttij(ii,nobs-1)<tt)continue;
          if(ii==iileave)continue;
          for(jj=0;jj<nobs;jj++){
            if(abs(ttij(ii,jj)-tt)>=hh_int)continue;
            diff=ttij(ii,jj)-tt;
            k=hh*hh-diff*diff;
            U(0)=U(0)+k;
            U(1)=U(1)+k*diff;
            U(2)=U(2)+k*diff*diff;
            V(0)=V(0)+k*rrij(ii,jj);
            V(1)=V(1)+k*diff*rrij(ii,jj);
          }
        }
        mu_leave(jjleave)=(U(2)*V(0)-U(1)*V(1))/(U(2)*U(0)-U(1)*U(1));
        if(ISNAN(mu_leave(jjleave))&&jjleave>0){
          mu_leave(jjleave)=mu_leave(jjleave-1);
        }
        diff=rrij(iileave,jjleave)-mu_leave(jjleave);
        CV(hh_index)=CV(hh_index)+diff*diff;
      }
    }
  }
  return CV;
}
