#include <Rcpp.h>
using namespace Rcpp;
using std::abs;
// [[Rcpp::export]]
NumericVector mean_est(NumericMatrix rrij, IntegerMatrix ttij, int hh_int, int ntimepoints){
  int nind=rrij.nrow();
  int nobs=rrij.ncol();
  NumericVector U(3);
  NumericVector V(2);
  NumericVector mu(ntimepoints);
  double diff=0;
  double k=0;
  double hh=hh_int;
  int tt,ii,jj;
  for(tt=0;tt<ntimepoints;tt++){
    U(0)=0;U(1)=0;U(2)=0;
    V(0)=0;V(1)=0;
    for(ii=0;ii<nind;ii++){
      if(ttij(ii,nobs-1)<tt)continue;
      for(jj=0;jj<nobs;jj++){
        if(abs(ttij(ii,jj)-tt)>=hh_int)continue;
        diff=ttij(ii,jj)-tt;
        k=hh*hh-diff*diff;
        U(0)=U(0)+k;
        U(1)=U(1)+k*diff;
        U(2)=U(2)+k*diff*diff;
        V(0)=V(0)+k*rrij(ii,jj);
        V(1)=V(1)+k*diff*rrij(ii,jj);
      }
    }
    mu(tt)=(U(2)*V(0)-U(1)*V(1))/(U(2)*U(0)-U(1)*U(1));
  }
  return mu;
}
